{ Real Delete 0.01
 (C) 2007-2012, Andreas Berg. All Rights Reserved. }
program realdel;

uses
 Crt, SysUtils, _common, _conv, _diskio, _pbar;

const
 CurVer             = '0.01';

var
 dFile              : string;
 ch                 : char;

 err, f             : boolean;
 i                  : integer;
 s                  : string;

 doDel, conf        : boolean;
 oTimes             : integer;

 perc1, perc2       : integer;
 operc1, operc2     : integer;
 bx1, bx2, by1, by2 : integer;

 buf                : array[0..1024] of byte;
 bb                 : integer;

 ff                 : file of byte;
 fpos, fsize        : int64;
 tpos, tsize        : int64;


function StrToValue(s: string; defValue: integer): integer;
var
 cval, rval         : integer;
 i, ln, f           : integer;
begin
   cval:= 0;
   rval:= defValue;
   f:= 1;
   ln:= length(s);
   if ln > 0 then begin
      for i:= 1 to ln do begin
         if not (s[i] in ['0'..'9']) then begin
            Writeln('ERROR: Invalid value [' + s + ']!');
            err:= true;
         end;
      end;
      if not err then begin
         if ln < 3 then begin
            for i:= ln downto 1 do begin
               cval:= cval + ((ord(s[i]) - ord('0')) * f);
               f:= f * 10;
            end;
            rval:= cval;
         end else begin
            Writeln('ERROR: Value too big [' + s + ']!');
            err:= true;
         end;
      end;
   end else begin
      Writeln('ERROR: Value expected!');
      err:= true;
   end;
   StrToValue:= rval;
end;


begin
   write('Real Delete ' + CurVer);
   writeln(' / (C) 2007-2012, Andreas Berg. All Rights Reserved.');

   if paramcount < 1 then begin
      writeln('usage:  realdel  file  [options]');
      WriteLn('');
      WriteLn('OPTION              DESCRIPTION');
      Writeln(' -t:<times>         Overwrite <times> (default = 1, max = 99)');
      Writeln(' -c                 Confirm deletion');
      Writeln('');
   end else begin
      writeln;

      err:= false;
      dFile:= '';
      doDel:= true;
      conf:= false;
      oTimes:= 1;

      for i:= 1 to ParamCount do begin
         s:= ParamStr(i);
         if s[1] = '-' then begin
            f:= false;
            if UpperCase(s) = '-C' then begin
               conf:= true;
               doDel:= false;
               f:= true;
            end;
            if UpperCase(copy(s, 1, 3)) = '-T:' then begin
               oTimes:= StrToValue(copy(s, 4, length(s) - 3), oTimes);
               if err then break;
               f:= true;
            end;

            if not f then begin
               Writeln('ERROR: Invalid option [' + s + ']!');
               err:= true;
            end;
         end else begin
            if dFile = '' then
             dFile:= ParamStr(i)
            else begin
               Writeln('ERROR: Filename already set!');
               err:= true;
            end;
         end;
      end;

      if (dFile = '') and (not err) then begin
         Writeln('ERROR: No input file!');
         err:= true;
      end;

      if not err then begin

         if FileExists(dFile) then begin

            if conf then begin
               write('Do you want to delete [' + dFile + ']? [Y/n]: ');
               repeat
               until KeyPressed;
               ch:= ReadKey;
               if UpCase(ch) = 'Y' then doDel:= true;
               write(ch);
               writeln;
               writeln;
            end;

            if doDel then begin

               if oTimes > 0 then begin
                  perc1:= 0;
                  perc2:= 0;
                  operc1:= 0;
                  operc2:= 0;
                  Write('Total      : ');
                  bx1:= WhereX;
                  bx2:= bx1;
                  Writeln;
                  Writeln;
                  Write('Overwriting: ');
                  by2:= WhereY;
                  by1:= by2 - 2;

                  Assign(ff, dFile);
                  Reset(ff);
                     fsize:= FileSize(ff);
                  Close(ff);
                  tsize:= (fsize * oTimes);
                  fpos:= 0;
                  tpos:= 0;

                  for i:= 1 to oTimes do begin
                     for bb:= 0 to 1023 do buf[bb]:= random(255);

                     Assign(ff, dFile);
                     Rewrite(ff);
                        if fsize > 0 then begin
                           fpos:= 0;
                           while fpos < fsize do begin
                              if (fsize - fpos) >= 1024 then begin
                                 BlockWrite(ff, buf[0], 1024);
                                 fpos:= fpos + 1024;
                              end else begin
                                 BlockWrite(ff, buf[0], (fsize-fpos));
                                 fpos:= fsize;
                              end;
                              perc2:= ((fpos * 100) div fsize);
                              if (perc2 > 100) then perc2:= 100;

                              tpos:= ((i-1) * fsize) + fpos;
                              perc1:= ((tpos * 100) div tsize);
                              if (perc1 > 100) then perc1:= 100;

                              if perc1 <> operc1 then begin
                                 DrawProgressBar(bx1, by1, BarSize, tpos, tsize);
                                 operc1:= perc1;
                              end;
                              if perc2 <> operc2 then begin
                                 DrawProgressBar(bx2, by2, BarSize, fpos, fsize);
                                 operc2:= perc2;
                              end;

                           end;
                        end;
                     Close(ff);
                  end;
                  DrawProgressBar(bx1, by1, BarSize, tsize, tsize);
                  DrawProgressBar(bx2, by2, BarSize, fsize, fsize);

                  writeln;
                  writeln;
               end;

               if DeleteFile(dFile) then begin
                  writeln('*** DONE ***');
                  writeln;
               end else begin
                  Writeln('ERROR: Could not delete [' + dFile + ']!');
               end;

            end;
         end else begin
            writeln('ERROR: File not found [' + dFile + ']!');
         end;
      end;

   end;
end.
